// this program controls a robot with a "trap" on the front. The robot finds objects and
// pushes them to a "soccer" goal with a beacon behind it, as described in an article
// published in Servo Magazine.

#include "RROScommands.bas"
#include "InitializationRoutines.bas"
gosub InitRROScommands  // found in the first include file
gosub InitMagicianRobot // found in second include file

MainProgram:
  rCommand(SetSenseInvMask,0)
  while true
    gosub ObtainBall
    if rSense()&1 then gosub MoveToBeacon
    rForward -40
    rTurn 100
  wend
return

MoveToBeacon:
  // first face the beacon
  rCommand(SetSpeed,40)
  rCommand(SetTurnStyle,0)
  while not rBeacon(0)
    rTurn -1  // rotate to left
  wend
  // then move to it
  rTurn 10
  rCommand(SetTurnStyle,0)
  
  while !(rFeel()&4) //(rSense()&1) and not(rSense()&6)
    rForward 1
    if rBeacon(0) 
      rTurn 1
    else
      rTurn -1
    endif
  wend
return


ObtainBall:
  repeat
    rCommand(SetSpeed,25)
    repeat
      // look for object
      found = 0
      for i=1 to 100
        d = rRange()
        rTurn -1
        if d<40 //and rBeacon(0)  // ignore goal
          found=1
          rTurn -4
          break
        endif
      next     
      if not found
        rTurn -20
        if rRange()>20 then rForward 20
      endif
    until found    
    // some object now in view - move to it
    found = 0
    for i=1 to 100
      rForward 1
      print rSense()
      if rSense()
         found=1
         break
      endif
    next  
    if found // arrived at an object, now see if it might be a "ball"
      found = 0
      for i=1 to 100    // try to get it in the hand, but only for a short time
        if rSense()=1   // assume it is a ball if it will fit in the hand
          found = 1
          break
        endif
        if rSense()=6   // it is a big object, perhaps a wall or the goal
          rForward -40
          rTurn -30
        endif
        while rSense()=2
          rTurn 1
        wend
        while rSense()=4
          rTurn -1
        wend
        rForward 1
      next
    endif
  until found  
  rForward 3  
return


